﻿using System;
using System.Collections;
using System.IO;
using System.Text;
using System.Threading;
using System.Web.UI;
using System.Xml;
using visinia.SmartEngine.Utility;

public partial class Admin_AdminMenu : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        LiteralControl menu = new LiteralControl(Render());
        Controls.Add(menu);
    }

    private string Render()
    {
        StringBuilder sb = new StringBuilder();
        sb.Append("<ul id=\"sidemenu\">");
        string pages = Server.MapPath(WebRoots.GetAdminRoot() + "Pages");
        string[] pageDirs = Directory.GetFileSystemEntries(pages);
        int index = 0;
        sb.Append("<li><h4 id=\"Index_" + index + "\">Site</h4>");
        sb.Append("<ul>");        
        sb.Append("<li><a href=\"" + WebRoots.GetWebRoot() + "\" >" + "Show Site" + "</a></li>");
        sb.Append("</ul>");
        sb.Append("</li>");
        foreach (string dir in pageDirs)
        {
            XmlDocument pagesdoc = new XmlDocument();
            string name = dir.Substring((dir.LastIndexOf('\\') + 1));
            string file = pages + "\\" + name + "\\Menu.Data";
            if (File.Exists(file))
            {
                pagesdoc.Load(file);
                XmlNode pagesroot = pagesdoc.DocumentElement;
                if (pagesroot == null)
                    continue;
                IEnumerator pagesienum = pagesroot.GetEnumerator();
                XmlNode pagesnode;
                while (pagesienum.MoveNext())
                {
                    pagesnode = (XmlNode)pagesienum.Current;
                    string pagesname = pagesnode.Attributes["name"].Value;                    
                    XmlAttribute roleattrib = pagesnode.Attributes["role"];
                    bool global = false;
                    string role = "";
                    if (roleattrib == null)
                        global = true;
                    else
                        role = pagesnode.Attributes["role"].Value;
                    if (Thread.CurrentPrincipal.IsInRole(role) ||
                        (Thread.CurrentPrincipal.IsInRole("admin")) ||
                         (global))
                    {
                        string pagesurl = WebRoots.GetAdminRoot() + "Default.aspx?page=" + pagesnode.Attributes["value"].Value;
                        ++index;
                        sb.Append("<li><h4 id=\"Index_" + index + "\">" + pagesname + "</h4>");
                        XmlNodeList pageschildren = pagesnode.ChildNodes;
                        if (pageschildren.Count > 0)
                        {
                            sb.Append("<ul>");
                            IEnumerator pagesichildenum = pageschildren.GetEnumerator();
                            XmlNode pageschildnode;
                            while (pagesichildenum.MoveNext())
                            {
                                pageschildnode = (XmlNode)pagesichildenum.Current;
                                string cname = pageschildnode.Attributes["name"].Value;
                                string curl = WebRoots.GetAdminRoot() + "Default.aspx?page=" + pageschildnode.Attributes["value"].Value + "&PageName=" + pagesname;
                                sb.Append("<li><a href=\"" + curl + "\" >" + cname + "</a></li>");
                            }
                            sb.Append("</ul>");
                        }
                        sb.Append("</li>");
                    }
                }
            }
        }
        sb.Append("</ul>");
        return sb.ToString();
    }
}
