﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI;
using visinia.SmartEngine.Modules;
using visinia.SmartEngine.Repository;

public partial class Admin_Controls_ModuleRepository : System.Web.UI.UserControl
{
    // an orphan = if a pane in theme is renamed or deleted which has modules in it those modules 
    // are called orphan modules, and they will not show up on the page
    //so those modules will be displayed here.
    public List<ModuleInfo> OrphanModules = null;

    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected override void Render(HtmlTextWriter writer)
    {
        StringBuilder sb = new StringBuilder();
        // building tabs
        sb.Append("<div id=\"Module_Tabs\">");
        sb.Append("<ul class=\"tabs\">");
        GetPackages().ForEach(delegate(ModuleInstalled module)
        {
            sb.Append("<li><a href=\"#" + module.Package + "\" >" + module.Package + "</a></li>");
        });
        // load orphan modules                        
        if (OrphanModules.Count > 0)
        {
            sb.Append("<li><a href=\"#OrphanModules\" >OrphanModules</a></li>");
        }
        sb.Append("</ul>");        

        // tab contents
        sb.Append("<div class=\"tab_container\">");
        sb.Append("<div id=\"Module_Repository_Info\"><p>Repository Info</p><br/><hr/>");
        sb.Append("<p>Name :</p><p id=\"RepositoryName\"></p>");
        sb.Append("</div>");
        sb.Append("<div class=\"ModulesColumn\" id=\"ModulesColumn\">");
        GetPackages().ForEach(delegate(ModuleInstalled module)
        {
            sb.Append("<div id=\"" + module.Package + "\" class=\"tab_content\">");
            sb.Append(AddContents(module.Package));
            sb.Append("</div>");
        });
        // load orphan modules                        
        if (OrphanModules.Count > 0)
        {
            sb.Append("<div id=\"OrphanModules\" class=\"tab_content\">");
            sb.Append(AddOrphanModulesContent());
            sb.Append("</div>");
        }
        sb.Append("</div>");
        sb.Append("</div>");
        sb.Append("</div>");
        writer.Write(sb);
    }

    private List<ModuleInstalled> GetPackages()
    {
        List<ModuleInstalled> modules = ModulesInstalledController.GetInstalledModules();
        List<ModuleInstalled> DistinctPackages = new List<ModuleInstalled>();
        foreach (ModuleInstalled module in modules)
        {
            if (!DistinctPackages.Exists(p => p.Package == module.Package))
                DistinctPackages.Add(module);
        }
        return DistinctPackages;
    }

    private string AddContents(string Package)
    {
        List<ModuleInstalled> modules = ModulesInstalledController.GetInstalledModules();
        List<string> text = new List<string>();
        List<string> links = new List<string>();
        foreach (ModuleInstalled module in modules)
        {
            if (module.Package == Package)
            {
                text.Add(module.Name);
                links.Add(module.ModuleInstalledId.ToString());
            }
        }
        return GenerateBulletedListHyperLinksDragOnly(text.ToArray(), links.ToArray());
    }

    private static string GenerateBulletedListHyperLinksDragOnly(string[] TextArray, string[] Links)
    {
        StringBuilder sb = new StringBuilder();
        for (int index = 0; index < TextArray.Length; index++)
        {
            sb.Append("<div class=\"dragbox\" id=\"" + Links[index] + "\" >");
            sb.Append("<h2>" + TextArray[index] + "</h2>");
            sb.Append("</div>");
        }
        return sb.ToString();
    }

    private string AddOrphanModulesContent()
    {
        StringBuilder sb = new StringBuilder();
        OrphanModules.ForEach(delegate(ModuleInfo module)
        {
            sb.Append("<div class=\"dragbox\" id=\"" + module.ModuleId + "\" >");
            sb.Append("<h2>" + ModulesInstalledController.GetInstalledModule(module.ModuleInstalledId).Name + "</h2>");
            sb.Append("<p>" + "[Title]" + module.Title + "</p>");
            sb.Append("<p>" + "[Pane]" + module.Pane + "</p>");
            sb.Append("</div>");
        });
        return sb.ToString();
    }
}
