﻿using System;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using visinia.SmartEngine.Utility;

public partial class Admin_Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        AddScriptVariables();        
        WebHelpers.AddClientScript(Page, "jquery/jquery-1.3.2.min.js");
        // for easy and light weight data transfer
        WebHelpers.AddClientScript(Page, "json/jquery.json-2.2.min.js");
        // for admin page sidebar accordion
        WebHelpers.AddClientScript(Page, "jquery/ui.core.js");
        WebHelpers.AddClientScript(Page, "jquery/ui.accordion.js");
        // jquery ui styles
        AddClientCss("jquery/jquery-ui-1.7.2.custom.css");
        // admin related js function
        WebHelpers.AddClientScript(Page, "Admin/Utility.js");

        if (Request.QueryString["page"] == null)
            return;
        PageName.Value = Request.QueryString["PageName"];
        string page = Request.QueryString["page"] + ".ascx";
        Control control = LoadControl(WebRoots.GetAdminRoot() + "Pages/" + page);
        Container.Controls.Add(control);        
    }

    private void AddScriptVariables()
    {
        string root = "<input type=\"hidden\" value=\"" + WebRoots.GetWebRoot() + "\" id=\"WebRoots_GetWebRoot\" />";
        LiteralControl rootctrl = new LiteralControl(root);
        Page.Header.Controls.Add(rootctrl);
    }

    private void AddClientCss(string cssfile)
    {
        HtmlGenericControl css = new HtmlGenericControl("link");
        css.Attributes["type"] = "text/css";
        css.Attributes["rel"] = "stylesheet";
        css.Attributes["href"] = WebRoots.GetClientScriptsRoot() + cssfile;
        Page.Header.Controls.Add(css);
    }
}
