﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI.WebControls;
using viNews.Classes;
using viNews.Controllers;
using visinia.SmartEngine.Utility;
using System.Web.UI.HtmlControls;

public partial class Admin_Pages_viNews_News_NewsEditor : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            List<Tag> tags = TagController.GetTags();
            //TAGS.DataTextField = "Name";
            //TAGS.DataValueField = "TagId";
            //TAGS.DataBind();
            foreach (Tag tag in tags)
            {
                HtmlAnchor a = new HtmlAnchor();
                a.InnerText = tag.Name;                
                TagsList.Controls.Add(a);
            }

            AUTHORS.DataSource = Membership.GetAllUsers();
            AUTHORS.DataBind();            
            //create a new entry
            if (Request.QueryString["NewsId"] == null)
            {
                DATE.Text = DateTime.Now.ToString();
                PUBLISH.Checked = true;
                hNewsId.Value = "0";
            }
            else
            {
                // edit an already existing news
                int NewsId = Convert.ToInt32(Request.QueryString["NewsId"]);
                hNewsId.Value = NewsId.ToString();
                News news = NewsController.GetNews(NewsId, false);
                TITLE.Text = news.Title;
                DATE.Text = news.Date.ToString();
                if (string.IsNullOrEmpty(news.Url))//this news's category is deleted
                {
                    CATEGORY.Control.Items.Insert(0, "< No Category >");
                    CATEGORY.Control.SelectedIndex = 0;
                }
                else
                {
                    //URL.Visible = true;
                    URL.Text = news.Url;
                    CATEGORY.CategoryId = news.Category;
                }
                if (!string.IsNullOrEmpty(news.ImageUrl))
                {
                    //NewsImageAttachmentUrl.Value = news.ImageUrl;
                    //NewsImagePreview.Src = WebRoots.GetResourcesRoot() + news.ImageUrl;
                    //NewsImagePreview.Visible = true;
                }
                SUMMARY.Text = news.Summary;
                PUBLISH.Checked = news.Publish;
                DESCRIPTION.Text = NewsController.GetNewsDescription(NewsId, false);

                //List<Tag> tags = TagController.GetTags(NewsId);
                //if (tags != null)
                //{
                //    foreach (Tag tag in tags)
                //    {
                //        TAGS.Items.FindByValue(tag.TagId.ToString()).Selected = true;
                //    }
                //}
            }
        }
    }

    protected void SAVE_Click(object sender, EventArgs e)
    {
        //save a new news
        if (Request.QueryString["NewsId"] == null)
        {
            AddNews();
        }
        else
        {// update an already existing news           
            int newsid = 0;
            if (!Int32.TryParse(Request.QueryString["NewsId"], out newsid))
                return;
            News news = NewsController.GetNews(newsid, false);
            if (news == null)
                return;
            news.Title = TITLE.Text;
            news.Author = AUTHORS.SelectedValue;
            news.Date = Convert.ToDateTime(DATE.Text);
            if (CATEGORY.Control.Text != "< No Category >")
                news.Category = CATEGORY.CategoryId;
            news.Url = RemoveIllegalCharacters(news.Title);
            news.ImageUrl = NewsImageAttachmentUrl.Value;            
            news.Summary = SUMMARY.Text;
            news.Publish = PUBLISH.Checked;
            NewsController.UpdateNews(news, DESCRIPTION.Text);

            //List<Tag> tags = TagController.GetTags(news.NewsId);
            //if (tags != null)
            //{
            //    foreach (ListItem tag in TAGS.Items)
            //    {
            //        if (tag.Selected)
            //        {
            //            int tagid = Convert.ToInt32(tag.Value);
            //            if (!tags.Exists(p => p.TagId == tagid))
            //                TagController.InsertTag(tagid, newsid);
            //        }
            //        else
            //        {
            //            int tagid = Convert.ToInt32(tag.Value);
            //            if (tags.Exists(p => p.TagId == tagid))
            //                TagController.RemoveTag(tagid, newsid);
            //        }
            //    }
            //}
        }
        Response.Redirect(Request.RawUrl);
    }

    private void AddNews()
    {
        News news = new News();
        news.Title = TITLE.Text;
        news.Author = AUTHORS.SelectedValue;
        news.Date = Convert.ToDateTime(DATE.Text);
        news.Category = CATEGORY.CategoryId;
        news.Url = RemoveIllegalCharacters(news.Title);
        news.ImageUrl = NewsImageAttachmentUrl.Value;        
        news.Summary = SUMMARY.Text;
        news.Publish = PUBLISH.Checked;
        int newsid = NewsController.AddNews(news, DESCRIPTION.Text);
        //if (newsid != 0)// add tags
        //{
        //    foreach (ListItem tag in TAGS.Items)
        //    {
        //        if (tag.Selected)
        //            TagController.InsertTag(Convert.ToInt32(tag.Value), newsid);
        //    }
        //}
    }

    protected void CANCEL_Click(object sender, EventArgs e)
    {
        Response.Redirect(Request.RawUrl);
    }
    
    private static string RemoveIllegalCharacters(string Title)
    {
        if (string.IsNullOrEmpty(Title))
            return Title;

        Title = Title.Replace(":", string.Empty);
        Title = Title.Replace("/", string.Empty);
        Title = Title.Replace("?", string.Empty);
        Title = Title.Replace("#", string.Empty);
        Title = Title.Replace("[", string.Empty);
        Title = Title.Replace("]", string.Empty);
        Title = Title.Replace("@", string.Empty);
        Title = Title.Replace("*", string.Empty);
        Title = Title.Replace(".", string.Empty);
        Title = Title.Replace(",", string.Empty);
        Title = Title.Replace("\"", string.Empty);
        Title = Title.Replace("&", string.Empty);
        Title = Title.Replace("'", string.Empty);
        Title = Title.Replace(" ", "-");
        return HttpUtility.UrlEncode(Title).Replace("%", string.Empty);
    }
}
