﻿$(function(){
    $.ui.dialog.defaults.bgiframe = true;
    
    // show module settings
    $('.dragbox .TitleBar .ModuleButtons .configure').live('click', function(){
        // remove leading #Configure
        var moduleId = $(this).attr("href").substr(10);                
        configureModule(moduleId, this);
    });       

    // delete module
    $('.dragbox .TitleBar .ModuleButtons .delete').live('click', function(){       
        if(!confirm('Are you sure?'))
            return false;	    
        // remove leading #Delete
        var moduleId = $(this).attr("href").substr(7);
        deleteModule(moduleId, this);
    });    
    
	$('.column').sortable({
		connectWith: '.column',
		handle: '.TitleBar',
		cursor: 'move',
		placeholder: 'placeholder',
		forcePlaceholderSize: true,
		opacity: 0.4,
		start: function(event, ui){
			//Firefox, Safari/Chrome fire click event after drag is complete, fix for that
			//if($.browser.mozilla || $.browser.safari)
			
		},
		stop: function(event, ui){
			ui.item.css({'top':'0','left':'0'}); //Opera fix
			//if(!$.browser.mozilla && !$.browser.safari)
				updateModulesData();
		}
	}).disableSelection();
});

function updateModulesData(){
	var items=[];
	var pageid = $('.CurrentPageClass').val();
	$('.column').each(function(){
		var columnId=$(this).attr('id');
		$('.dragbox', this).each(function(i){
			//Create Item object for current panel
			var item={
				moduleid: $(this).attr('id'),
				pageid: pageid,
				order : i,
				pane: columnId				
			};
			//Push item object into items array
			items.push(item);
		});
	});
	//Assign items array to sortorder JSON variable
	var sortorder={ items: items };
	//Pass sortorder variable to server using ajax to save state
	ShowProgress('Updating the Server...');
	$.post('Admin/Pages/System/Modules/ModuleController.aspx?UpdatePanes=True', 'data='+$.toJSON(sortorder), function(response){
		//if(response=="success")			
			HideProgress();
	});
}

function deleteModule(ModuleId, which){	                
    ShowProgress('Updating the Server...');
    $.post('Admin/Pages/System/Modules/ModuleController.aspx?DeleteModule=True&ModuleId=' + ModuleId, function(response){
    if(response=="success"){            
            var parent = $(which).parents('.dragbox');
            parent.fadeOut(2000);            
		    setTimeout(function(){
			    parent.remove();
		    }, 2000);
		}
    });
    HideProgress();
}
       
function configureModule(ModuleId, source){
    ShowProgress('Loading...');
    $('#basic-modal-container').html('<div id="basic-modal-content" title="Module Settings"></div>');    
    $.post('Admin/Pages/System/Modules/ModuleController.aspx?ModuleSettings=True&ModuleId=' + ModuleId, function(data) {                            
        $('#basic-modal-content').html(data);
        HideProgress();
        $('#basic-modal-content').dialog({
            modal: true,        
            width: 500,
            overlay: { backgroundColor: "#000", opacity: 0.5 },
            buttons: {                                             
                 "Cancel": function() {
                     $('#form1').remove();
                     $(this).dialog('close');
                  },
                 "Save": function() {                                                
                         //send data to server                                                 
                         // the following serializeArray() function is
                         // tinkerd a bit, this version of serializeArray()
                         // retrieves the form control values by there
                         // css class names, The original gets values by the control id                                                 
                         var serializedData = $('#form1').serializeArray();
                         var jsonData = $.toJSON(serializedData);
                         // the values are html encoded
                         // may be some module settings try to post html data 
                         //                                        [tanvon malik] 25May2010  7:18PM
                         var data = escape(jsonData);                                                    
                         //Pass variable to server using ajax to save state
                         $.post('Admin/Pages/System/Modules/ModuleController.aspx?SaveSettings=True', 'data='+ data , function(data){                                                                    
                                            var parent = $(source).parents('.dragbox');                                                                    
                                            parent.before(data);
                                            parent.remove();                                                                                                                                
                         });                                                 
                         $('#form1').remove();
                         $(this).dialog('close');                                                 
                    }//save
                }//buttons
        });
    });        
}