﻿using System;
using System.Web.UI;
using visinia.SmartEngine.Modules;
using visinia.SmartEngine.Pages;
using visinia.SmartEngine.Site;
using visinia.SmartEngine.Utility;

namespace visinia.Web
{
    public partial class DefaultPage : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {   //disable viewstate
            EnableViewState = false;
            WebPageController.CURRENT_MODE = WebPageController.MODES.USER;            
            // TODO remove from variable from pageheader
            AddScriptVariables();
            WebHelpers.AddClientScript(Page, "jquery/jquery-1.3.2.min.js");
            // for easy and light weight data transfer
            WebHelpers.AddClientScript(Page, "json/jquery.json-2.2.min.js");
            PageInfo page = PageController.GetPage(Convert.ToInt32(Request.QueryString["PageId"]));
            if (!string.IsNullOrEmpty(page.Title))
                Title = page.Title;
            WebPageController.LoadModules(page.PageId, Page);
            Page.DataBind();
        }

        void Page_PreInit(Object sender, EventArgs e)
        {
            PageInfo page = PageController.GetPage(Convert.ToInt32(Request.QueryString["PageId"]));
            MasterPageFile = WebRoots.GetThemesRoot() + SiteSettings.Theme + "/page.master";            
        }

        private void AddScriptVariables()
        {
            string root = "<input type=\"hidden\" value=\"" + WebRoots.GetWebRoot() + "\" id=\"WebRoots_GetWebRoot\" />";
            LiteralControl rootctrl = new LiteralControl(root);
            Page.Form.Controls.Add(rootctrl);
        }
    }
}
