﻿using System;
using System.Threading;
using System.Web.UI;
using visinia.SmartEngine.Modules;
using visinia.SmartEngine.Pages;
using visinia.SmartEngine.Site;
using visinia.SmartEngine.Utility;

namespace visinia.Web
{
    public partial class Designer : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if ((Thread.CurrentPrincipal.IsInRole("designer") || (Thread.CurrentPrincipal.IsInRole("admin"))))
            {
                //disable viewstate
                EnableViewState = false;
                WebPageController.CURRENT_MODE = WebPageController.MODES.DESIGNER;
                PageInfo page = PageController.GetPage(Convert.ToInt32(Request.QueryString["PageId"]));
                if (page == null)
                    return;
                AddScriptVariables();

                WebHelpers.AddClientScript(Page, "jquery/jquery-1.3.2.min.js");
                // for easy and light weight data transfer
                WebHelpers.AddClientScript(Page, "json/jquery.json-2.2.min.js");
                // designer mode general purpose functions
                WebHelpers.AddClientScript(Page, "designer/utility.js");
                // dependencies for ui.dialog.js
                WebHelpers.AddClientScript(Page, "jquery/ui.core.js");
                WebHelpers.AddClientScript(Page, "jquery/ui.draggable.js");
                WebHelpers.AddClientScript(Page, "jquery/ui.resizable.js");
                // for module properties dialog
                WebHelpers.AddClientScript(Page, "jquery/ui.dialog.js");
                // for module repository tabs etc.
                WebHelpers.AddClientScript(Page, "jquery/ui.tabs.js");
                // jquery ui styles for dialog etc.
                WebHelpers.AddClientCss(Page, "jquery/jquery-ui-1.7.2.custom.css");
                // for module drag and drop
                WebHelpers.AddClientScript(Page, "jquery/ui.sortable.js");
                // module drag drop & module properties controller
                WebHelpers.AddClientScript(Page, "designer/module.js");
                // module repository tabs etc.
                WebHelpers.AddClientScript(Page, "designer/modulerepository.js");
                // designer mode styles
                WebHelpers.AddClientCss(Page, "designer/styles.css");

                if (!string.IsNullOrEmpty(page.Title))
                    Title = page.Title;
                WebPageController.LoadDesignerModeModules(page.PageId, Page);
                Page.DataBind();
            }
        }

        void Page_PreInit(Object sender, EventArgs e)
        {
            PageInfo page = PageController.GetPage(Convert.ToInt32(Request.QueryString["PageId"]));
            if (page == null)
                return;            
            MasterPageFile = WebRoots.GetThemesRoot() + SiteSettings.Theme + "/page.master";
        }

        private void AddScriptVariables()
        {
            string root = "<input type=\"hidden\" value=\"" + WebRoots.GetWebRoot() + "\" id=\"WebRoots_GetWebRoot\" />";
            LiteralControl rootctrl = new LiteralControl(root);
            Page.Form.Controls.Add(rootctrl);
        }        
    }
}
