﻿using System;
using System.Collections.Generic;
using System.Web.UI;
using viBlog.Classes;
using viBlog.Controllers;
using visinia.SmartEngine.Modules;
using visinia.SmartEngine.Utility;

public partial class Modules_viBlog_Dynamic_PostsRotator : WebModule
{
    protected void Page_Load(object sender, EventArgs e)
    {
        WebHelpers.AddClientScript(Page, "common/Rotator.js");
        WebHelpers.AddClientCss(Page, "common/Rotator.css");
    }

    protected override void WebModuleRender(HtmlTextWriter output)
    {
        List<Post> list = DataFilterController.GetFilteredData(ModuleId);
        if (list == null)
            return;
        List<string> text = new List<string>();
        List<string> links = new List<string>();
        foreach (Post post in list)
        {
            text.Add(post.Title);
            links.Add(post.Url);
        }
        ModuleInfo module = ModuleController.GetModule(ModuleId);
        string data = WebHelpers.GenerateBulletedListHyperLinks(module.CssClass, text.ToArray(), links.ToArray());
        output.Write(data);
    }
}
