﻿using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using viBlog.Classes;
using viBlog.Controllers;
using visinia.SmartEngine.Modules;

public partial class Modules_viBlog_RecentComments_RecentComments : WebModule
{
    protected void Page_Load(object sender, EventArgs e)
    {
        int count = 0;
        if (Int32.TryParse((string)Settings["Count"], out count))
        {
            if (count < 1)
                return;
            List<Comment> comments = CommentController.GetRecentComments(5);
            if (comments == null)
                return;
            List<CommentData> DataList = new List<CommentData>();
            foreach (Comment comment in comments)
            {
                Post post = PostController.GetPost(comment.PostId);
                if (post == null)
                    continue;
                CommentData data = new CommentData();
                data.Title = post.Title;
                data.Url = post.Url;
                data.Author = comment.Author;
                data.Date = comment.Date;
                DataList.Add(data);
            }
            RecentCommentsList.DataSource = DataList;
            RecentCommentsList.DataBind();
        }
    }

    public class CommentData
    {
        private string _Title;
        public string Title
        {
            get { return _Title; }
            set { _Title = value; }
        }
        private string _Url;        
        public string Url
        {
            get { return _Url; }
            set { _Url = value; }
        }
        private string _Author;
        public string Author
        {
            get { return _Author; }
            set { _Author = value; }
        }
        private DateTime _Date;
        public DateTime Date
        {
            get { return _Date; }
            set { _Date = value; }
        }
    }
}
