﻿using System;
using System.Collections.Generic;
using viForum.Classes;
using viForum.Controllers;
using visinia.SmartEngine.Modules;
using visinia.SmartEngine.Utility;

public partial class Modules_viForum_ThreadView_ThreadView : WebModule
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string forumidstr = Request.QueryString["ForumId"];
        if (!string.IsNullOrEmpty(forumidstr))
        {
            int forumid = 0;
            if (Int32.TryParse(forumidstr, out forumid))
            {
                Forum forum = ForumController.GetForum(forumid);
                if (forum != null)
                {
                    List<BaseThread> list = new List<BaseThread>();
                    int threadid = 0;
                    if (Int32.TryParse(Request.QueryString["ThreadId"], out threadid))
                    {
                        Thread thread = ThreadController.GetThread(threadid);
                        // SEO            
                        SeoController.AddPageTitle(Page, thread.Title);

                        List<Reply> replies =  ReplyController.GetReplies(threadid);
                        list.Add(thread);
                        foreach (Reply reply in replies)
                        {
                            list.Add(reply);
                        }                        
                        ThreadViewList.DataSource = list;
                        ThreadViewList.DataBind();
                    }
                }
            }
        }        
    }

    public string GetThreadTitle()
    {
        int threadid = 0;
        if (Int32.TryParse(Request.QueryString["ThreadId"], out threadid))
        {
            Thread thread = ThreadController.GetThread(threadid);
            return thread.Title;
        }
        return null;
    }

    public int GetUserPostsCount(string UserName)
    {
        User user = UserController.GetUser(UserName);
        if (user != null)
            return user.PostsCount;
        else
            return 0;
    }

    protected void AddReply_Click(object sender, EventArgs e)
    {        
        int threadid = 0;
        if (Int32.TryParse(Request.QueryString["ThreadId"], out threadid))
        {            
            Response.Redirect(WebRoots.GetWebRoot() + "Forum/Editor/AddReply/" + Request.QueryString["ForumId"] + "/" + Request.QueryString["ThreadId"] + BaseController.viForumExtension);
        }        
    }
}
