﻿using System;
using System.Collections.Generic;
using System.Web.UI;
using viNews.Classes;
using viNews.Controllers;
using visinia.SmartEngine.Modules;

public partial class Modules_viNews_News : WebModule
{
    protected void Page_Load(object sender, EventArgs e)
    {
        String csname = "viNewsPager";
        String csurl = ResolveUrl("~/ClientScripts/viNews/pager.js");
        ClientScriptManager cs = Page.ClientScript;
        if (!cs.IsClientScriptIncludeRegistered(csname))
        {
            cs.RegisterClientScriptInclude(csname, csurl);
        }
        string page = Request.QueryString["Page"];
        int CurrentPage = 0;
        Int32.TryParse(page, out CurrentPage);
        Bind(CurrentPage);
    }

    private void Bind(int CurrentPage)
    {           
        int pages = DataFilterController.GetFilteredDataPagesCount(ModuleId);
        CurrentPageState.Value = CurrentPage.ToString();
        if (pages >= CurrentPage)
        {
            if (pages > CurrentPage)
                pager_Next.Visible = true;
            else
                pager_Next.Visible = false;
            if (CurrentPage > 0)
                pager_Prev.Visible = true;
            else
                pager_Prev.Visible = false;
            List<News> list = DataFilterController.GetFilteredData(ModuleId, CurrentPage);
            NEWS.DataSource = list;
            NEWS.DataBind();
        }
    }    
    
    public int GetCommentsCount(int NewsId)
    {
        return CommentController.GetCommentsCount(NewsId);
    }   
}
